#include <iostream.h>
#define TRUE 1
#define FALSE 0
#define M 10 //    .
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L 
{ 
  int Key; //  .
  int Count; // .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct T 
{ 
  Lref Id; 
  Tref Next; 
};

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    int Fun[M+1]; //  .
    int NewFun[M+1]; //    Fun.
    void SearchGraph (int, Lref *);
    Lref Search(int);
    Boolean Find_Arc (int, int);
    Boolean Isomorph (Spisok, int);
  public:
    Spisok() {//   .
              Head = Tail =  new (L); }
    Lref GetHead() { return Head; }
    Lref GetTail() { return Tail; }
    void MakeGraph ();
    void PrintGraph ();
    void Sorting ();
    friend void Reshenie(Spisok,Spisok);
};

void main ()
{
  Spisok A,B;

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  B.MakeGraph ();
  B.PrintGraph (); cout<<endl;
  A.Sorting ();
  A.PrintGraph (); cout<<endl;
  B.Sorting ();
  B.PrintGraph (); cout<<endl;
  //.
  Reshenie(A,B);
}

void Reshenie(Spisok A, Spisok B)
// .
{
   Lref Ukaz;      //    
                   //    .
   int P[M+1];     //  .
   int Ves[M+1];   // ""   P
                   //(    ).
   int Ves1[M+1];  // -   Ves,     
                   // -  .
   Boolean Fl;     //   Ves  Ves1.
   Boolean PR[M+1];
   int C[M+1];
   int x,k,t;

  //    .
  int N=0;
  Ukaz = A.GetHead();
  while (Ukaz!=A.GetTail())
    { N++; 
      A.Fun[N] = A.NewFun[N] = Ukaz->Key; Ves[N] = Ukaz->Count;
      Ves1[N] = Ves[N]; Ukaz = Ukaz->Next;
    }
  N=0;
  Ukaz = B.GetHead();
  while (Ukaz!=B.GetTail())
    { N++; 
      B.Fun[N] = Ukaz->Key; Ukaz = Ukaz->Next;
    }
  for (int i=1;i<=N;i++) cout << Ves[i] << " "; cout << endl;
  for (i=1;i<=N;i++) cout << A.Fun[i] << " "; cout << endl;
  for (i=1;i<=N;i++) cout << B.Fun[i] << " "; cout << endl;
  //.
  for (i=1;i<=N;i++)
    { P[i] = i; C[i] = 1; PR[i] = TRUE; }
  // .
  C[N] = 0;
  cout << " ,  : \n";
  if ( A.Isomorph (B,N) )
  {
    for(int j=1;j<=N;j++) A.NewFun[j] = A.Fun[P[j]];
    for(j=1;j<=N;j++) cout << A.NewFun[j] << " ";
    cout << endl;
    for(j=1;j<=N;j++) cout << B.Fun[j] << " ";
    cout << endl;
  }
  cout << " --------------------------- \n";
  i = 1;
  while ( i<N )
  {
    i = 1; x = 0;
    while ( C[i]==N-i+1 )
    {
       PR[i] = (!PR[i]); C[i] = 1;
       if ( PR[i]) x++;
       i++;
    }
    if ( i<N )
    // .
    {
       if ( PR[i] )  k = C[i] + x;
       else  k = N - i + 1 - C[i] + x;
       t = P[k]; P[k] = P[k+1]; P[k+1] = t;
       t = Ves1[k]; Ves1[k] = Ves1[k+1];
       Ves1[k+1] = t; C[i] += 1;
       //  .
       Fl = TRUE;
       for (int j=1;j<=N;j++) Fl = (Fl && (Ves[j]==Ves1[j]));
       if ( Fl )
       {
          for (j=1;j<=N;j++) A.NewFun[j] = A.Fun[P[j]];
          if (A.Isomorph (B,N))
          {
             for (j=1;j<=N;j++) cout << A.NewFun[j] << " ";
             cout << endl;
             for (j=1;j<=N;j++) cout << B.Fun[j] << " ";
             cout << endl;
             cout << " --------------------------- \n";
           }
       }
    }
  }
}

Lref Spisok::Search (int w)
//      
// w.   ,    NULL .
{
  Lref h = Head;
  (*Tail).Key = w; // " ".
  while ((*h).Key!=w) h = (*h).Next;
  if (h==Tail) //        w.
    h = NULL;
  return h;
} 

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (L); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (T); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<< "(" << (*p).Count << ")" << (*p).Key << "("; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}

Boolean Spisok::Find_Arc (int x, int y)
//  TRUE,   , 
//  (Head,Tail),   (x,y).
{

  Lref p,q;    // .
  Tref r;      // .
  Boolean Res; //  .

  //,      (x,y)?
  p = Search (x);
  q = Search (y);
  r = p->Trail; Res = FALSE;
  while  ( r != NULL && !Res ) 
    if  (r->Id==q) Res = TRUE;
    else  r = r->Next;
  return Res;
}

void Spisok::Sorting ()
//    
//  Count   .
{
  Lref UkZv_1,UkZv_2;
  Lref UkZv_3;
  Tref UkZv_4;
  int  A, B;
  Tref D;

  UkZv_1 = Head;
  while ( UkZv_1 != Tail )
  {
    UkZv_2 = UkZv_1->Next;
    while  ( UkZv_2!=Tail )
    {
      if ( UkZv_1->Count < UkZv_2->Count )
      {
        A              = UkZv_1->Key;
        B              = UkZv_1->Count;
        D              = UkZv_1->Trail;
        UkZv_1->Key    = UkZv_2->Key;
        UkZv_1->Count  = UkZv_2->Count;
        UkZv_1->Trail  = UkZv_2->Trail;
        UkZv_2->Key    = A;
        UkZv_2->Count  = B;
        UkZv_2->Trail  = D;
        UkZv_3 = Head;
        while ( UkZv_3!=Tail )
        {
          UkZv_4 = UkZv_3->Trail;
          while ( UkZv_4 != NULL )
          {
            if ( UkZv_4->Id==UkZv_1 ) UkZv_4->Id = UkZv_2;
            else  
               if ( UkZv_4->Id==UkZv_2 ) UkZv_4->Id=UkZv_1;
            UkZv_4 = UkZv_4->Next;
          }
          UkZv_3 = UkZv_3->Next;
        }
      }
      UkZv_2 = UkZv_2->Next;
    }
    UkZv_1 = UkZv_1->Next;
  }
}

Boolean Spisok::Isomorph (Spisok B, int N)
//,  TRUE,   ,  
//  (A.Head,A.Tail)  (B.Head,B.Tail), .
//          
//NewFun  Fun.
{

  Boolean Flag = TRUE;
  int k1,k2;

  for (int i=1;i<=N;i++)
  {
    k1 = 1;
    while ( i != this->NewFun[k1] ) k1++;
    for (int j=1;j<=N;j++)
    {
      k2 = 1;
      while ( j != this->NewFun[k2] )  k2++;
       if  ( i>j && this->Find_Arc(i,j) )
          Flag = (Flag && B.Find_Arc (B.Fun[k1],B.Fun[k2]));
    }
  }
  return Flag;
}

